#include <qstring.h>
#include <vector>
using namespace std;

class IndexBuilder {
public:
  IndexBuilder();
  virtual void build( const char *basefilename );	// *.xml
  
// protected:
  struct lookupEntry {
	QChar c;
	int word_number, dchilds_count, childs_count;
	QString word;
	vector <lookupEntry*> sub;
  };

  struct lookupEntryExt {
	short c;
	int word_number, dchilds_count, childs_count;
	int child_offs[0];
  };

  lookupEntry rootNode;
  vector <lookupEntry*> *lookupTable;
  
  void addToLookupTable( QString word, int word_num );

  int acount;
  int build_index( const char *xmlname, const char *idxname );
  void build_wordlist( const char *xmlfile, const char *idxfile,
  	const char *wordsfile );
  
  struct word_desc {
	int dict_pos, offs;
  };

  vector <word_desc> words;
  static char *words_start;

  static bool less_worddesc( const word_desc &w1, const word_desc &w2 );
  void map_words( char *fname, char* &words_start, int& lenwords );
  void unmap_words( char *words_start, int lenwords );
  void process_idx( char *idxname, char *idxname2 );
  void sort_words( char *idxfile, char *idxfile2,
  	char *wordsfile );
  void write_tree( FILE *f, lookupEntry *ent );
};

class IndexBuilderDsl: public IndexBuilder {
public:
  IndexBuilderDsl();
  virtual void build( const char *datname );	// *.dat
protected:
  char *dslidx, *dsldat;
  char *idxname, *wordsname;

  int build_index();
  void build_wordlist();
};
