#if !defined(__NANOCOM_H__)
#define __NANOCOM_H__

#if defined(_MSC_VER)
#pragma once
#endif

#include "error.h"

#ifdef __linux__
#define STDCALL __attribute__((stdcall))
#else
#define STDCALL __stdcall
#endif

struct IBase : IErrorCode
{
    virtual int STDCALL QueryInterface( const char* ifname, void ** object) = 0;
    virtual long STDCALL AddRef( void) = 0;
    virtual long STDCALL Release( void) = 0;
    virtual int  STDCALL GetLastError( void) = 0;
};

#if defined(UNICODE)
typedef const wchar_t* LPCTSTR;
typedef const wchar_t* LPCWSTR;
IBase* NcCreateInstanceW( LPCWSTR libName, void ** ppComponent);
#define NcCreateInstance NcCreateInstanceW
#else
typedef const char* LPCTSTR;
typedef const char* LPCSTR;
IBase* NcCreateInstanceA( LPCSTR libName, void ** ppComponent);
#define NcCreateInstance NcCreateInstanceA
#endif

void NcDestroyInstance( void ** ppComponent);

#endif // __NANOCOM_H__ 

