#if defined(__linux__)

#include <stdio.h>
#include <dlfcn.h>
#include "error.h"
#include "nanocom.h"

typedef IBase* (*CREATEFUNCPTR)();

IBase* NcCreateInstance( LPCTSTR libName, void ** ppComponent)
{
    *ppComponent = ::dlopen( libName, RTLD_LAZY);
    if (*ppComponent == NULL)
    {
	printf( "dlopen: %s\n", dlerror() );
        return NULL;
    }
    
    CREATEFUNCPTR createFunc = (CREATEFUNCPTR)::dlsym( *ppComponent, "CreateInstance");
    if (createFunc == NULL)
    {
	printf( "dlsym: %s\n", dlerror() );
        NcDestroyInstance( ppComponent);
        return NULL;
    }
    
    return createFunc();
}

void NcDestroyInstance( void ** ppComponent)
{
    if (ppComponent != NULL)
    {
        ::dlclose( *ppComponent);
        ppComponent = NULL;
    }
}

#endif
