#include "stdafx.h"
#include "error.h"
#include "nanocom.h"

typedef IBase* (*CREATEFUNCPTR)();

IBase* NcCreateInstance( LPCTSTR libName, void ** ppComponent)
{
    *ppComponent = ::LoadLibrary( libName);
    if (*ppComponent == NULL)
    {
        return NULL;
    }
    
    CREATEFUNCPTR createFunc = (CREATEFUNCPTR)::GetProcAddress((HMODULE) *ppComponent, "CreateInstance");
    if (createFunc == NULL)
    {
        NcDestroyInstance( ppComponent);
        return NULL;
    }
    
    return createFunc();
}

void NcDestroyInstance( void ** ppComponent)
{
    if (ppComponent != NULL)
    {
        ::FreeLibrary((HMODULE) *ppComponent);
        ppComponent = NULL;
    }
}
